diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index 15a57940b..4072c74cd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -1,25 +1,25 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.tag.ItemTags;
-import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicFenceGate
     extends BlockLogic
@@ -29,30 +29,31 @@ public class BlockLogicFenceGate
     public static final int MASK_POWERED = 0b0000_1000;
 
     public BlockLogicFenceGate(final @NotNull Block<?> block) {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final int metadata = source.getBlockData(tilePos);
         if (isOpen(metadata)) {
             return null;
         } else {
-            return this.getAABBFromMeta(metadata).grow(0, 0.25f, 0).move(tilePos.x, tilePos.y + 0.25f, tilePos.z);
+            AABBd collisionBB = (AABBd) this.getAABBFromMeta(metadata);
+            return MathHelper.aabbGrow(collisionBB, 0, 0.25f, 0, collisionBB).translate(tilePos.x(), tilePos.y() + 0.25f, tilePos.z());
         }
     }
 
-    private @NotNull AABB getAABBFromMeta(final int meta) {
+    private @NotNull AABBdc getAABBFromMeta(final int meta) {
         if (getDirection(meta) == 3 || getDirection(meta) == 1) {
-            return AABB.fromPool(0.375f, 0, 0, 1 - 0.375f, 1.0F, 1f);
+            return new AABBd(0.375f, 0, 0, 1 - 0.375f, 1.0F, 1f);
         } else {
-            return AABB.fromPool(0, 0, 0.375f, 1, 1.0f, 1 - 0.375f);
+            return new AABBd(0, 0, 0.375f, 1, 1.0f, 1 - 0.375f);
         }
 
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.getAABBFromMeta(source.getBlockData(tilePos));
     }
 
@@ -67,19 +68,19 @@ public class BlockLogicFenceGate
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         final int direction = mob.getHorizontalPlacementDirection(side).getHorizontalIndex();
         final int meta = world.getBlockData(tilePos);
         world.setBlockDataNotify(tilePos, direction | (meta & ~MASK_DIRECTION));
     }
 
     @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, @NotNull Side side, final double xHit, final double yHit) {
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, @NotNull Side side, final double xHit, final double yHit) {
         if (!side.isHorizontal()) {
             side = Side.NORTH;
         }
@@ -89,14 +90,14 @@ public class BlockLogicFenceGate
     }
 
     @Override
-    public void onAttacked(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onAttacked(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
         if (!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
             this.onInteracted(world, tilePos, player, null, 0.0, 0.0);
         }
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @Nullable Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @Nullable Player player, final @Nullable Side side, final double xHit, final double yHit) {
         int data = world.getBlockData(tilePos);
         if (isOpen(data)) {
             world.setBlockDataNotify(tilePos, data & ~MASK_OPEN);
@@ -118,7 +119,7 @@ public class BlockLogicFenceGate
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         final int data = world.getBlockData(tilePos);
         final boolean wasPowered = isPowered(data);
         final boolean hasPower = world.hasNeighborSignal(tilePos) || world.hasDirectSignal(tilePos);
@@ -132,7 +133,7 @@ public class BlockLogicFenceGate
     }
 
     @Override
-    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
+    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
         this.onInteracted(world, tilePos, null, direction.getSide(), 0.5, 0.5);
     }
 
@@ -149,7 +150,7 @@ public class BlockLogicFenceGate
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         world.setBlockIdDataNotify(tilePos, Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id(), world.getBlockData(tilePos));
         Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.getLogic().setColor(world, tilePos, color);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
index 333f0809b..f280a126d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
@@ -7,7 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -19,7 +19,7 @@ public class BlockLogicFenceGatePainted extends BlockLogicFenceGate implements I
     }
 
     @Override
-    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         return itemStack.getMetadata();
     }
 
@@ -44,13 +44,13 @@ public class BlockLogicFenceGatePainted extends BlockLogicFenceGate implements I
     }
 
     @Override
-    public void removeDye(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataNotify(tilePos, Blocks.FENCE_GATE_PLANKS_OAK.id(), meta & ~MASK_COLOR);
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         IPainted.super.setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
index 7d8a7de7f..9b3700013 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
@@ -7,7 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -17,7 +17,7 @@ public class BlockLogicFencePainted extends BlockLogicFence implements IPainted
     }
 
     @Override
-    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         return itemStack.getMetadata();
     }
 
@@ -42,12 +42,12 @@ public class BlockLogicFencePainted extends BlockLogicFence implements IPainted
     }
 
     @Override
-    public void removeDye(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         world.setBlockIdNotify(tilePos, Blocks.FENCE_PLANKS_OAK.id());
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         IPainted.super.setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
index d134922f6..30c787238 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -15,8 +16,9 @@ public class BlockLogicFenceSteel
     }
 
     @Override
-    public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection()));
-        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection())) == side.getOpposite());
+    public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        TilePos queryPos = new TilePos();
+        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection(), queryPos));
+        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
index 643aaa660..4629a5fb3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
@@ -4,12 +4,14 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 
@@ -25,7 +27,7 @@ public abstract class BlockLogicFenceThin
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (side.isVertical()) {
             return PartialSupport.INSTANCE.center();
         } else {
@@ -34,44 +36,44 @@ public abstract class BlockLogicFenceThin
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final boolean connectEast = this.canConnectTo(source, tilePos, Side.EAST);
         final boolean connectWest = this.canConnectTo(source, tilePos, Side.WEST);
         final boolean connectSouth = this.canConnectTo(source, tilePos, Side.SOUTH);
         final boolean connectNorth = this.canConnectTo(source, tilePos, Side.NORTH);
-        return AABB.fromPool((connectWest ? 0.0f : 0.375f), 0, (connectNorth ? 0.0f : 0.375f), 1 - (connectEast ? 0.0f : 0.375f), 1, 1 - (connectSouth ? 0.0f : 0.375f));
+        return new AABBd((connectWest ? 0.0f : 0.375f), 0, (connectNorth ? 0.0f : 0.375f), 1 - (connectEast ? 0.0f : 0.375f), 1, 1 - (connectSouth ? 0.0f : 0.375f));
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         final boolean connectEast = this.canConnectTo(source, tilePos, Side.EAST);
         final boolean connectWest = this.canConnectTo(source, tilePos, Side.WEST);
         final boolean connectSouth = this.canConnectTo(source, tilePos, Side.SOUTH);
         final boolean connectNorth = this.canConnectTo(source, tilePos, Side.NORTH);
-        return AABB.fromPool((connectWest ? 0.0f : 0.375f), 0, (connectNorth ? 0.0f : 0.375f), 1 - (connectEast ? 0.0f : 0.375f), 1, 1 - (connectSouth ? 0.0f : 0.375f));
+        return new AABBd((connectWest ? 0.0f : 0.375f), 0, (connectNorth ? 0.0f : 0.375f), 1 - (connectEast ? 0.0f : 0.375f), 1, 1 - (connectSouth ? 0.0f : 0.375f));
     }
 
     @Override
-    public void getCollisionAABBs(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull AABB aabb, final @NotNull List<@NotNull AABB> aabbList) {
+    public void getCollisionAABBs(@NotNull World world, @NotNull TilePosc tilePos, @NotNull AABBdc aabb, @NotNull List<@NotNull AABBdc> aabbList) {
         final boolean connectEast = this.canConnectTo(world, tilePos, Side.EAST);
         final boolean connectWest = this.canConnectTo(world, tilePos, Side.WEST);
         final boolean connectSouth = this.canConnectTo(world, tilePos, Side.SOUTH);
         final boolean connectNorth = this.canConnectTo(world, tilePos, Side.NORTH);
         final double thickness = 0.5 - 0.375;
         if (connectEast) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 1, 1, 0.5 + thickness).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0.5 - thickness, 0, 0.5 - thickness, 1, 1, 0.5 + thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
         if (connectWest) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0, 0, 0.5 - thickness, 0.5 + thickness, 1, 0.5 + thickness).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0, 0, 0.5 - thickness, 0.5 + thickness, 1, 0.5 + thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
         if (connectSouth) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1, 1).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1, 1).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
         if (connectNorth) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0, 0.5 + thickness, 1, 0.5 + thickness).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0.5 - thickness, 0, 0, 0.5 + thickness, 1, 0.5 + thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
         if (!connectEast && !connectWest && !connectSouth && !connectNorth) {
-            this.addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1, 0.5 + thickness).move(tilePos), aabbList);
+            this.addIntersectingBoundingBox(aabb, new AABBd(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1, 0.5 + thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
         }
     }
 
@@ -85,26 +87,27 @@ public abstract class BlockLogicFenceThin
         return false;
     }
 
-    public abstract boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side);
+    public abstract boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side);
 
     @Deprecated
     public final boolean canConnectTo(final @NotNull WorldSource world, final int x, final int y, final int z, final @NotNull Side side) {
         return this.canConnectTo(world, new TilePos(x, y, z), side);
     }
 
-    public boolean shouldDrawColumn(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public boolean shouldDrawColumn(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final boolean drawColumn = this.shouldDrawColumn_do(source, tilePos);
         if (drawColumn) return true;
 
+        TilePos queryPos = new TilePos();
         int oy = 1;
-        while (source.getBlockId(tilePos.add(0, oy, 0)) == this.block.id()) {
+        while (source.getBlockId(tilePos.add(0, oy, 0, queryPos)) == this.block.id()) {
             oy++;
         }
         oy--;
 
         boolean drawColumnFromOther = false;
-        while (source.getBlockId(tilePos.add(0, oy, 0)) == this.block.id()) {
-            if (this.shouldDrawColumn_do(source, tilePos.add(0, oy, 0))) {
+        while (source.getBlockId(tilePos.add(0, oy, 0, queryPos)) == this.block.id()) {
+            if (this.shouldDrawColumn_do(source, tilePos.add(0, oy, 0, queryPos))) {
                 drawColumnFromOther = true;
                 break;
             }
@@ -114,7 +117,7 @@ public abstract class BlockLogicFenceThin
         return drawColumnFromOther;
     }
 
-    private boolean shouldDrawColumn_do(final @NotNull WorldSource world, final @NotNull TilePos tilePos) {
+    private boolean shouldDrawColumn_do(final @NotNull WorldSource world, final @NotNull TilePosc tilePos) {
         final boolean connectNorth = this.canConnectTo(world, tilePos, Side.NORTH);
         final boolean connectSouth = this.canConnectTo(world, tilePos, Side.SOUTH);
         final boolean connectEast = this.canConnectTo(world, tilePos, Side.EAST);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
index c8417f3d7..83afe05c4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -15,8 +16,9 @@ public class BlockLogicFenceWallPaper
     }
 
     @Override
-    public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection()));
-        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection())) == side.getOpposite());
+    public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        TilePos queryPos = new TilePos();
+        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection(), queryPos));
+        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
     }
 }
